COSMO.ENVIRON <- new.env(hash=TRUE, parent=parent.frame(1))

intervalNumAndType <- function(titlename="", intFixedto2=FALSE){
    if (!intFixedto2){
        label1 <- label(wName="label1",
                        wValue="Number of intervals: ", wEnv=COSMO.ENVIRON)
        
        entry1 <- entryBox(wName="entry1", wValue="?", wEnv=COSMO.ENVIRON,
                           wWidth=10)
        
        pWidgets <- list(line1=list(label1=label1, entry1=entry1))
        widgetIntNum <- widget(wTitle=paste(titlename,
                                 "Number of intervals input window", sep=""), pWidgets,
                               funs=list(), preFun=function() {},                               
                               postFun=function() {}, env=COSMO.ENVIRON)
        n <- as.numeric(wValue(pWidgets(widgetIntNum)[["line1"]][["entry1"]]))
    }
    else {
        n <- 2
    }

    if (n>5) {warning("The motif may only be broken into a maximum of 5 intervals"); break}

    labelD  <- label(wName="labelD",
                     wValue="Select the interval types:", wEnv=COSMO.ENVIRON)
    labelR1a <- label(wName="labelR1a",
                      wValue="Interval 1: ", wEnv=COSMO.ENVIRON)
    radios1a <- radioButton(wName="radios1a",
                            wValue=c(BasePairs=FALSE, Percentage=FALSE, Variable=TRUE), wEnv=COSMO.ENVIRON)
    labelR1b <- label(wName="labelR1b",
                      wValue="Value: ", wEnv=COSMO.ENVIRON)
    entryR1b <- entryBox(wName="entryR1b", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    labelR2a <- label(wName="labelR2a",
                      wValue="Interval 2: ", wEnv=COSMO.ENVIRON)
    radios2a <- radioButton(wName="radios2a",
                            wValue=c(BasePairs=FALSE, Percentage=FALSE, Variable=TRUE), wEnv=COSMO.ENVIRON)
    labelR2b <- label(wName="labelR2b",
                      wValue="Value: ", wEnv=COSMO.ENVIRON)
    entryR2b <- entryBox(wName="entryR2b", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    labelR3a <- label(wName="labelR3a", wValue="Interval 3: ", wEnv=COSMO.ENVIRON)
    radios3a <- radioButton(wName="radios3a",
                            wValue=c(BasePairs=FALSE, Percentage=FALSE, Variable=TRUE), wEnv=COSMO.ENVIRON)
    labelR3b <- label(wName="labelR3b", wValue="Value: ", wEnv=COSMO.ENVIRON)
    entryR3b <- entryBox(wName="entryR3b", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    labelR4a <- label(wName="labelR4a", wValue="Interval 4: ", wEnv=COSMO.ENVIRON)
    radios4a <- radioButton(wName="radios4a",
                            wValue=c(BasePairs=FALSE, Percentage=FALSE, Variable=TRUE), wEnv=COSMO.ENVIRON)
    labelR4b <- label(wName="labelR4b", wValue="Value: ", wEnv=COSMO.ENVIRON)
    entryR4b <- entryBox(wName="entryR4b", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    labelR5a <- label(wName="labelR5a", wValue="Interval 5: ", wEnv=COSMO.ENVIRON)
    radios5a <- radioButton(wName="radios5a",
                            wValue=c(BasePairs=FALSE, Percentage=FALSE, Variable=TRUE), wEnv=COSMO.ENVIRON)
    labelR5b <- label(wName="labelR5b", wValue="Value: ", wEnv=COSMO.ENVIRON)
    entryR5b <- entryBox(wName="entryR5b", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    labelB  <- label(wName="labelB", wValue="\n \n", wEnv=COSMO.ENVIRON)
    labelRe  <- label(wName="labelRe",
                      wValue="If type is BasePairs, then the value is the number of base pairs. \n If type is Percentage, then the value is the percentage of the motif made up by this interval (between 0 and 100).",
                      wEnv=COSMO.ENVIRON)
    if (n == 1){
        pWidgets <- list(descrip=list(labelD=labelD),
                line1a=list(labelR1a=labelR1a, radios1a=radios1a),
                line1b=list(labelR1b=labelR1b, entryR1b=entryR1b),
                blank=list(labelB=labelB),
                recall=list(labelRe=labelRe))
        widgetIntType <- widget(wTitle=paste(titlename,
                                  "Interval yypes input window",
                                  sep=""),
                                pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)    
    }
    else if (n == 2){
        pWidgets <- list(descrip=list(labelD=labelD),
                line1a=list(labelR1a=labelR1a, radios1a=radios1a),
                line1b=list(labelR1b=labelR1b, entryR1b=entryR1b),
                line2a=list(labelR2a=labelR2a, radios2a=radios2a),
                line2b=list(labelR2b=labelR2b, entryR2b=entryR2b),
                blank=list(labelB=labelB),
                recall=list(labelRe=labelRe))
        widgetIntType <- widget(wTitle=paste(titlename,
                                  "Interval types input window",
                                  sep=""),
                                pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)    
    }
    else if (n == 3){
        pWidgets <- list(descrip=list(labelD=labelD),
                line1a=list(labelR1a=labelR1a, radios1a=radios1a),
                line1b=list(labelR1b=labelR1b, entryR1b=entryR1b),
                line2a=list(labelR2a=labelR2a, radios2a=radios2a),
                line2b=list(labelR2b=labelR2b, entryR2b=entryR2b),
                line3a=list(labelR3a=labelR3a, radios3a=radios3a),
                line3b=list(labelR3b=labelR3b, entryR3b=entryR3b),
                blank=list(labelB=labelB),
                recall=list(labelRe=labelRe))
        widgetIntType <- widget(wTitle=paste(titlename,
                                  "Interval types input window",
                                  sep=""),
                                pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)    
    }
    else if (n == 4){
        pWidgets <- list(descrip=list(labelD=labelD),
                line1a=list(labelR1a=labelR1a, radios1a=radios1a),
                line1b=list(labelR1b=labelR1b, entryR1b=entryR1b),
                line2a=list(labelR2a=labelR2a, radios2a=radios2a),
                line2b=list(labelR2b=labelR2b, entryR2b=entryR2b),
                line3a=list(labelR3a=labelR3a, radios3a=radios3a),
                line3b=list(labelR3b=labelR3b, entryR3b=entryR3b),
                line4a=list(labelR4a=labelR4a, radios4a=radios4a),
                line4b=list(labelR4b=labelR4b, entryR4b=entryR4b),
                blank=list(labelB=labelB),
                recall=list(labelRe=labelRe))
        widgetIntType <- widget(wTitle=paste(titlename,
                                  "Interval types input window",
                                  sep=""),
                                pWidgets, funs=list(),
                                preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)    
    }
    else if (n == 5){
        pWidgets <- list(descrip=list(labelD=labelD),
                line1a=list(labelR1a=labelR1a, radios1a=radios1a),
                line1b=list(labelR1b=labelR1b, entryR1b=entryR1b),
                line2a=list(labelR2a=labelR2a, radios2a=radios2a),
                line2b=list(labelR2b=labelR2b, entryR2b=entryR2b),
                line3a=list(labelR3a=labelR3a, radios3a=radios3a),
                line3b=list(labelR3b=labelR3b, entryR3b=entryR3b),
                line4a=list(labelR4a=labelR4a, radios4a=radios4a),
                line4b=list(labelR4b=labelR4b, entryR4b=entryR4b),
                line5a=list(labelR5a=labelR5a, radios5a=radios5a),
                line5b=list(labelR5b=labelR5b, entryR5b=entryR5b),
                blank=list(labelB=labelB),
                recall=list(labelRe=labelRe))
        widgetIntType <- widget(wTitle=paste(titlename,
                                  "Interval types input window",
                                  sep=""),
                                pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)    
      }

    types <- sapply(1:n, function(i){
      c("B", "P", "V")[wValue(pWidgets(widgetIntType)[[paste("line", i, "a", sep="")]][[2]])]})
    values <- sapply(1:n, function(i){
      ifelse(as.numeric(wValue(pWidgets(widgetIntType)[[paste("line",
                                                              i, "b", sep="")]][[2]]))!=0,
             as.numeric(wValue(pWidgets(widgetIntType)[[paste("line", i, "b", sep="")]][[2]])), NA)})
    if (sum(types == "V")>1){
      warning("There can be at most one interval of variable length.")
      break}
    percentages <- values[types == "P"]
    bases <- values[types == "B"]
    if (length(percentages)>0 && (sum(!is.numeric(percentages))>0 |
                                  sum(percentages<0)>0 |
                                  sum(percentages>100)>0)){
      warning("Percentage values must be numeric between 0 and 100")
      break}
    if (length(bases)>0 && (sum(!is.numeric(bases))>0 ||
                            sum(bases<0)>0 ||
                            prod((is.numeric(bases) &
                                  as.integer(bases) == bases)) == 0)){
      warning("Base pair values must be integers strictly greater than 1");break}
    list(n, widgetIntType)
    
}

ICStep <- function(titlename="", n, sample=TRUE){
    labelD  <- label(wName="labelD",
                     wValue="The information content is assumed to be constant across each interval.",
                     wEnv=COSMO.ENVIRON)
    labelB1  <- label(wName="labelB1", wValue="\n", wEnv=COSMO.ENVIRON)
    label1a <- label(wName="label1a",
                     wValue="Across interval 1, the information content is constant with value between:                  ", wEnv=COSMO.ENVIRON)
    entry1a <- entryBox(wName="entry1a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label1b <- label(wName="label1b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry1b <- entryBox(wName="entry1b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label1c <- label(wName="label1c",
                     wValue="The information content profile across interval 1 may deviate from a constant function by at most: ", wEnv=COSMO.ENVIRON)
    entry1c <- entryBox(wName="entry1c", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    label2a <- label(wName="label2a",
                     wValue="Across interval 2, the information content is constant with value between:                  ", wEnv=COSMO.ENVIRON)
    entry2a <- entryBox(wName="entry2a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label2b <- label(wName="label2b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry2b <- entryBox(wName="entry2b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label2c <- label(wName="label2c",
                     wValue="The information content profile across interval 2 may deviate from a constant function by at most: ", wEnv=COSMO.ENVIRON)
    entry2c <- entryBox(wName="entry2c", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    label3a <- label(wName="label3a",
                     wValue="Across interval 3, the information content is constant with value between:                  ", wEnv=COSMO.ENVIRON)
    entry3a <- entryBox(wName="entry3a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label3b <- label(wName="label3b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry3b <- entryBox(wName="entry3b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label3c <- label(wName="label3c",
                     wValue="The information content profile across interval 3 may deviate from a constant function by at most: ", wEnv=COSMO.ENVIRON)
    entry3c <- entryBox(wName="entry3c", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    label4a <- label(wName="label4a",
                     wValue="Across interval 4, the information content is constant with value between:                  ", wEnv=COSMO.ENVIRON)
    entry4a <- entryBox(wName="entry4a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label4b <- label(wName="label4b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry4b <- entryBox(wName="entry4b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label4c <- label(wName="label4c",
                     wValue="The information content profile across interval 4 may deviate from a constant function by at most: ", wEnv=COSMO.ENVIRON)
    entry4c <- entryBox(wName="entry4c", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    label5a <- label(wName="label5a",
                     wValue="Across interval 5, the information content is constant with value between:                  ", wEnv=COSMO.ENVIRON)
    entry5a <- entryBox(wName="entry5a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label5b <- label(wName="label5b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry5b <- entryBox(wName="entry5b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label5c <- label(wName="label5c",
                     wValue="The information content profile across interval 5 may deviate from a constant function by at most: ", wEnv=COSMO.ENVIRON)
    entry5c <- entryBox(wName="entry5c", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    labelRe <- label(wName="labelRe",
                     wValue="(Recall that the information content is bounded between 0 and 2)", wEnv=COSMO.ENVIRON)
    labelB2  <- label(wName="labelB2", wValue="\n \n", wEnv=COSMO.ENVIRON)
    labelR  <- label(wName="labelR", wValue="Are there palindromic intervals?", wEnv=COSMO.ENVIRON)
    radios1 <- radioButton(wName="radios1", wValue=c(No=TRUE, Yes=FALSE), wEnv=COSMO.ENVIRON)
    labelPa <- label(wName="labelPa", wValue="(If Yes) Which intervals are palindromic?", wEnv=COSMO.ENVIRON)
    entryPa <- entryBox(wName="entryPa", wValue="?", wEnv=COSMO.ENVIRON, wWidth=3)
    labelPb <- label(wName="labelPb", wValue=" and ", wEnv=COSMO.ENVIRON)
    entryPb <- entryBox(wName="entryPb", wValue="?", wEnv=COSMO.ENVIRON, wWidth=3)
    labelPc <- label(wName="labelPc",
                     wValue="(If Yes) Corresponding nucleotide frequencies may deviate \n from each other by at most this proportion (between 0 and 1):",
                     wEnv=COSMO.ENVIRON)
    entryPc <- entryBox(wName="entryPc", wValue="?", wEnv=COSMO.ENVIRON, wWidth=4)    

    if (sample){
    if (n == 1){
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1a=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line1b=list(label1c=label1c, entry1c=entry1c),
                recall=list(labelRe=labelRe),
                blank2=list(labelB2=labelB2))
            widgetICStep=widget(wTitle=paste(titlename,
                                  "Step-function information content bounds", sep=""),
              pWidgets, funs=list(), preFun=function() {},
              postFun=function() {}, env=COSMO.ENVIRON)    
    }
    else if (n == 2){
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1a=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line1b=list(label1c=label1c, entry1c=entry1c),
                line2a=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line2b=list(label2c=label2c, entry2c=entry2c),
                recall=list(labelRe=labelRe),
                blank2=list(labelB2=labelB2),
                radios=list(labelR=labelR, radios1=radios1),
                palin=list(labelPa=labelPa, entryPa=entryPa, labelPb=labelPb, entryPb=entryPb),
                palin2=list(labelPc=labelPc, entryPc=entryPc))
        widgetICStep <- widget(wTitle=paste(titlename,
                                 "Step-function information content bounds", sep=""),
                               pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
        if
    (wValue(pWidgets(widgetICStep)[["radios"]][["radios1"]])[2]){
      warning("Warning: Palindromic intervals were declared. If the constraints on the two intervals are distinct, those for the first interval will be applied to the second.")}
    }
    else if (n == 3){
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1a=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line1b=list(label1c=label1c, entry1c=entry1c),
                line2a=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line2b=list(label2c=label2c, entry2c=entry2c),
                line3a=list(label3a=label3a, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                line3b=list(label3c=label3c, entry3c=entry3c),
                recall=list(labelRe=labelRe),
                blank2=list(labelB2=labelB2),
                radios=list(labelR=labelR, radios1=radios1),
                palin=list(labelPa=labelPa, entryPa=entryPa, labelPb=labelPb, entryPb=entryPb),
                palin2=list(labelPc=labelPc, entryPc=entryPc))
        widgetICStep <- widget(wTitle=paste(titlename,
                                 "Step-function information content bounds", sep=""),
                               pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
        if
    (wValue(pWidgets(widgetICStep)[["radios"]][["radios1"]])[2]){
      warning("Warning: Palindromic intervals were declared. If the constraints on the two intervals are distinct, those for the first interval will be applied to the second.")}
    }
    else if (n == 4){
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1a=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line1b=list(label1c=label1c, entry1c=entry1c),
                line2a=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line2b=list(label2c=label2c, entry2c=entry2c),
                line3a=list(label3a=label3a, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                line3b=list(label3c=label3c, entry3c=entry3c),
                line4a=list(label4a=label4a, entry4a=entry4a, label4b=label4b, entry4b=entry4b),
                line4b=list(label4c=label4c, entry4c=entry4c),
                recall=list(labelRe=labelRe),
                blank2=list(labelB2=labelB2),
                radios=list(labelR=labelR, radios1=radios1),
                palin=list(labelPa=labelPa, entryPa=entryPa, labelPb=labelPb, entryPb=entryPb),
                palin2=list(labelPc=labelPc, entryPc=entryPc))
        widgetICStep <- widget(wTitle=paste(titlename, "Step-function information content bounds", sep=""), pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
        if
    (wValue(pWidgets(widgetICStep)[["radios"]][["radios1"]])[2]){
      warning("Warning: Palindromic intervals were declared. If the constraints on the two intervals are distinct, those for the first interval will be applied to the second.")}
    }
    else if (n == 5){
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1a=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line1b=list(label1c=label1c, entry1c=entry1c),
                line2a=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line2b=list(label2c=label2c, entry2c=entry2c),
                line3a=list(label3a=label3a, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                line3b=list(label3c=label3c, entry3c=entry3c),
                line4a=list(label4a=label4a, entry4a=entry4a, label4b=label4b, entry4b=entry4b),
                line4b=list(label4c=label4c, entry4c=entry4c),
                line5a=list(label5a=label5a, entry5a=entry5a, label5b=label5b, entry5b=entry5b),
                line5b=list(label5c=label5c, entry5c=entry5c),
                recall=list(labelRe=labelRe),
                blank2=list(labelB2=labelB2),
                radios=list(labelR=labelR, radios1=radios1),
                palin=list(labelPa=labelPa, entryPa=entryPa, labelPb=labelPb, entryPb=entryPb),
                palin2=list(labelPc=labelPc, entryPc=entryPc))
        widgetICStep <- widget(wTitle=paste(titlename,
                                 "Step-function information content bounds", sep=""),
                               pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
        if
        (wValue(pWidgets(widgetICStep)[["radios"]][["radios1"]])[2]){
          warning("Warning: Palindromic intervals were declared. If the constraints on the two intervals are distinct, those for the first interval will be applied to the second.")}
      }
    }
    else if (!sample){
    if (n == 1){
        pWidgets <- list(descrip=list(labelD=labelD),
                line1a=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line1b=list(label1c=label1c, entry1c=entry1c),
                recall=list(labelRe=labelRe))
        widgetICStep <- widget(wTitle=paste(titlename,
                                 "Step-function information content bounds", sep=""), pWidgets,
                               funs=list(), preFun=function() {},                               
                               postFun=function() {}, env=COSMO.ENVIRON)    
    }
    else if (n == 2){
        pWidgets <- list(descrip=list(labelD=labelD),
                line1a=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line1b=list(label1c=label1c, entry1c=entry1c),
                line2a=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line2b=list(label2c=label2c, entry2c=entry2c),
                recall=list(labelRe=labelRe))
        widgetICStep <- widget(wTitle=paste(titlename,
                                 "Step-function information content bounds", sep=""),
                               pWidgets, funs=list(), preFun=function() {},
                               postFun=function() {}, env=COSMO.ENVIRON)
      }
    else if (n == 3){
        pWidgets <- list(descrip=list(labelD=labelD),
                line1a=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line1b=list(label1c=label1c, entry1c=entry1c),
                line2a=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line2b=list(label2c=label2c, entry2c=entry2c),
                line3a=list(label3a=label3a, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                line3b=list(label3c=label3c, entry3c=entry3c),
                recall=list(labelRe=labelRe))
        widgetICStep <- widget(wTitle=paste(titlename,
                                 "Step-function information content bounds", sep=""),
                               pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 4){
        pWidgets <- list(descrip=list(labelD=labelD),
                line1a=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line1b=list(label1c=label1c, entry1c=entry1c),
                line2a=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line2b=list(label2c=label2c, entry2c=entry2c),
                line3a=list(label3a=label3a, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                line3b=list(label3c=label3c, entry3c=entry3c),
                line4a=list(label4a=label4a, entry4a=entry4a, label4b=label4b, entry4b=entry4b),
                line4b=list(label4c=label4c, entry4c=entry4c),
                recall=list(labelRe=labelRe))
        widgetICStep <- widget(wTitle=paste(titlename,
                                 "Step-function information content bounds", sep=""),
                               pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 5){
        pWidgets <- list(descrip=list(labelD=labelD),
                line1a=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line1b=list(label1c=label1c, entry1c=entry1c),
                line2a=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line2b=list(label2c=label2c, entry2c=entry2c),
                line3a=list(label3a=label3a, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                line3b=list(label3c=label3c, entry3c=entry3c),
                line4a=list(label4a=label4a, entry4a=entry4a, label4b=label4b, entry4b=entry4b),
                line4b=list(label4c=label4c, entry4c=entry4c),
                line5a=list(label5a=label5a, entry5a=entry5a, label5b=label5b, entry5b=entry5b),
                line5b=list(label5c=label5c, entry5c=entry5c),
                recall=list(labelRe=labelRe))
        widgetICStep <- widget(wTitle=paste(titlename,
                                 "Step-function information content bounds", sep=""),
                               pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    }    

    widgetICStep

}

ICBound <- function(titlename="", n, sample=TRUE){
    labelD  <- label(wName="labelD", wValue=
                     "The information content is assumed to be bounded on each interval.",
                     wEnv=COSMO.ENVIRON)
    labelB1 <- label(wName="labelB1", wValue="\n", wEnv=COSMO.ENVIRON)
    label1a <- label(wName="label1a",
                     wValue="Across interval 1, the information content is contained between: ",
                     wEnv=COSMO.ENVIRON)
    entry1a <- entryBox(wName="entry1a", wValue=0, wEnv=COSMO.ENVIRON, wWidth=3)
    label1b <- label(wName="label1b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry1b <- entryBox(wName="entry1b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label2a <- label(wName="label2a",
                     wValue="Across interval 2, the information content is contained between: ", wEnv=COSMO.ENVIRON)
    entry2a <- entryBox(wName="entry2a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label2b <- label(wName="label2b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry2b <- entryBox(wName="entry2b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label3a <- label(wName="label3a",
                     wValue="Across interval 3, the information content is contained between: ", wEnv=COSMO.ENVIRON)
    entry3a <- entryBox(wName="entry3a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label3b <- label(wName="label3b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry3b <- entryBox(wName="entry3b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label4a <- label(wName="label4a",
                     wValue="Across interval 4, the information content is contained between: ", wEnv=COSMO.ENVIRON)
    entry4a <- entryBox(wName="entry4a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label4b <- label(wName="label4b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry4b <- entryBox(wName="entry4b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label5a <- label(wName="label5a",
                     wValue="Across interval 5, the information content is contained between: ", wEnv=COSMO.ENVIRON)
    entry5a <- entryBox(wName="entry5a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label5b <- label(wName="label5b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry5b <- entryBox(wName="entry5b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    labelRe <- label(wName="labelRe",
                     wValue="(Recall that the information content is bounded between 0 and 2)", wEnv=COSMO.ENVIRON)
    labelB2 <- label(wName="labelB2", wValue="\n \n", wEnv=COSMO.ENVIRON)
    labelR  <- label(wName="labelR", wValue="Are there palindromic intervals?", wEnv=COSMO.ENVIRON)
    radios1 <- radioButton(wName="radios1", wValue=c(No=TRUE, Yes=FALSE), wEnv=COSMO.ENVIRON)
    labelPa <- label(wName="labelPa", wValue="(If Yes) Which intervals are palindromic?", wEnv=COSMO.ENVIRON)
    entryPa <- entryBox(wName="entryPa", wValue="?", wEnv=COSMO.ENVIRON, wWidth=3)
    labelPb <- label(wName="labelPb", wValue=" and ", wEnv=COSMO.ENVIRON)
    entryPb <- entryBox(wName="entryPb", wValue="?", wEnv=COSMO.ENVIRON, wWidth=3)
    labelPc <- label(wName="labelPc",
                     wValue="(If Yes) Corresponding nucleotide frequencies may deviate \n from each other by at most this proportion (between 0 and 1):", wEnv=COSMO.ENVIRON)
    entryPc <- entryBox(wName="entryPc", wValue="?", wEnv=COSMO.ENVIRON, wWidth=4)
    
    if (sample){    
    if (n == 1){
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                recall=list(labelRe=labelRe),
                blank2=list(labelB2=labelB2),
                radios=list(labelR=labelR, radios1=radios1),
                palin=list(labelPa=labelPa, entryPa=entryPa, labelPb=labelPb, entryPb=entryPb),
                palin2=list(labelPc=labelPc, entryPc=entryPc))
        widgetICBound <- widget(wTitle="Information content bounds",
                                pWidgets, funs=list(), preFun=function() {},
                                postFun=function() {}, env=COSMO.ENVIRON)    
    }
    else if (n == 2){
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line2=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                recall=list(labelRe=labelRe),
                blank2=list(labelB2=labelB2),
                radios=list(labelR=labelR, radios1=radios1),
                palin=list(labelPa=labelPa, entryPa=entryPa, labelPb=labelPb, entryPb=entryPb),
                palin2=list(labelPc=labelPc, entryPc=entryPc))
        widgetICBound <- widget(wTitle="Information content bounds", pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 3){
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line2=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line3=list(label3a=label3a, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                recall=list(labelRe=labelRe),
                blank2=list(labelB2=labelB2),
                radios=list(labelR=labelR, radios1=radios1),
                palin=list(labelPa=labelPa, entryPa=entryPa, labelPb=labelPb, entryPb=entryPb),
                palin2=list(labelPc=labelPc, entryPc=entryPc))
        widgetICBound <- widget(wTitle="Information content bounds", pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 4){
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line2=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line3=list(label3a=label3a, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                line4=list(label4a=label4a, entry4a=entry4a, label4b=label4b, entry4b=entry4b),
                recall=list(labelRe=labelRe),
                blank2=list(labelB2=labelB2),
                radios=list(labelR=labelR, radios1=radios1),
                palin=list(labelPa=labelPa, entryPa=entryPa, labelPb=labelPb, entryPb=entryPb),
                palin2=list(labelPc=labelPc, entryPc=entryPc))
        widgetICBound <- widget(wTitle="Information content bounds", pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 5){
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line2=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line3=list(label3a=label3a, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                line4=list(label4a=label4a, entry4a=entry4a, label4b=label4b, entry4b=entry4b),
                line5=list(label5a=label5a, entry5a=entry5a, label5b=label5b, entry5b=entry5b),
                recall=list(labelRe=labelRe),
                blank2=list(labelB2=labelB2),
                radios=list(labelR=labelR, radios1=radios1),
                palin=list(labelPa=labelPa, entryPa=entryPa, labelPb=labelPb, entryPb=entryPb),
                palin2=list(labelPc=labelPc, entryPc=entryPc))
        widgetICBound <- widget(wTitle="Information content bounds", pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    }
    else if (!sample){    
    if (n == 1){
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                recall=list(labelRe=labelRe))
        widgetICBound <- widget(wTitle="Information content bounds", pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)    
    }
    else if (n == 2){
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line2=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                recall=list(labelRe=labelRe))
        widgetICBound <- widget(wTitle="Information content bounds", pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 3){
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line2=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line3=list(label3a=label3a, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                recall=list(labelRe=labelRe))
        widgetICBound <- widget(wTitle="Information content bounds", pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 4){
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line2=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line3=list(label3a=label3a, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                line4=list(label4a=label4a, entry4a=entry4a, label4b=label4b, entry4b=entry4b),
                recall=list(labelRe=labelRe))
        widgetICBound <- widget(wTitle="Information content bounds", pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 5){
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line2=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line3=list(label3a=label3a, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                line4=list(label4a=label4a, entry4a=entry4a, label4b=label4b, entry4b=entry4b),
                line5=list(label5a=label5a, entry5a=entry5a, label5b=label5b, entry5b=entry5b),
                recall=list(labelRe=labelRe))
        widgetICBound <- widget(wTitle="Information content bounds", pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    }

    widgetICBound

}

ICLinearCont <- function(titlename="" , n, sample=FALSE, titlename2="linearly"){
    labelD  <- label(wName="labelD",
                     wValue=paste("The information content is assumed to vary ",
                       titlename2,
                       " within intervals \n and is assumed to be continuous at junctions between intervals.",
                       sep=""), wEnv=COSMO.ENVIRON)
    labelB1 <- label(wName="labelB1", wValue="\n", wEnv=COSMO.ENVIRON)
    label1start <- label(wName="label1s",
                         wValue="At the beginning of interval 1, the information content is contained between:                             ", wEnv=COSMO.ENVIRON)
    entry1a <- entryBox(wName="entry1a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label1b <- label(wName="label1b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry1b <- entryBox(wName="entry1b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label1end <- label(wName="label1e",
                       wValue="At the end of interval 1, the information content is contained between:                                       ", wEnv=COSMO.ENVIRON)
    label2start <- label(wName="label2s",
                         wValue="At the end of interval 1 (beginning of interval 2), the information content is contained between: ", wEnv=COSMO.ENVIRON)
    entry2a <- entryBox(wName="entry2a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label2b <- label(wName="label2b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry2b <- entryBox(wName="entry2b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label2end <- label(wName="label2e",
                       wValue="At the end of interval 2, the information content is contained between:                                       ", wEnv=COSMO.ENVIRON)
    label3start <- label(wName="label3s", wValue="At the end of interval 2 (beginning of interval 3), the information content is contained between: ", wEnv=COSMO.ENVIRON)
    entry3a <- entryBox(wName="entry3a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label3b <- label(wName="label3b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry3b <- entryBox(wName="entry3b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label3end <- label(wName="label3e",
                       wValue="At the end of interval 3, the information content is contained between:                                       ", wEnv=COSMO.ENVIRON)
    label4start <- label(wName="label4s",
                         wValue="At the end of interval 3, (beginning of interval 4), the information content is contained between:  ", wEnv=COSMO.ENVIRON)
    entry4a <- entryBox(wName="entry4a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label4b <- label(wName="label4b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry4b <- entryBox(wName="entry4b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label4end <- label(wName="label4e",
                       wValue="At the end of interval 4, the information content is contained between:                                       ", wEnv=COSMO.ENVIRON)
    label5start <- label(wName="label5s", wValue="At the end of interval 4, (beginning of interval 5), the information content is contained between:  ", wEnv=COSMO.ENVIRON)
    entry5a <- entryBox(wName="entry5a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label5b <- label(wName="label5b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry5b <- entryBox(wName="entry5b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label5end <- label(wName="label5e",
                       wValue="At the end of interval 5, the information content is contained between:                                       ", wEnv=COSMO.ENVIRON)
    entry6a <- entryBox(wName="entry6a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label6b <- label(wName="label6b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry6b <- entryBox(wName="entry6b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    labelRe <- label(wName="labelRe",
                     wValue="(Recall that the information content is bounded between 0 and 2)", wEnv=COSMO.ENVIRON)
    labelB2  <- label(wName="labelB2", wValue="\n \n", wEnv=COSMO.ENVIRON)
    label1c <- label(wName="label1c", wValue="The total error allowed across interval 1 is: ", wEnv=COSMO.ENVIRON)
    entry1c <- entryBox(wName="entry1c", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    label2c <- label(wName="label2c", wValue="The total error allowed across interval 2 is: ", wEnv=COSMO.ENVIRON)
    entry2c <- entryBox(wName="entry2c", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    label3c <- label(wName="label3c", wValue="The total error allowed across interval 3 is: ", wEnv=COSMO.ENVIRON)
    entry3c <- entryBox(wName="entry3c", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    label4c <- label(wName="label4c", wValue="The total error allowed across interval 4 is: ", wEnv=COSMO.ENVIRON)
    entry4c <- entryBox(wName="entry4c", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    label5c <- label(wName="label5c", wValue="The total error allowed across interval 5 is: ", wEnv=COSMO.ENVIRON)
    entry5c <- entryBox(wName="entry5c", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
        
    if (n == 1){    
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1=list(label1start=label1start, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line2=list(label1end=label1end, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                recall=list(labelRe=labelRe),
                blank2=list(labelB2=labelB2),
                lineErr1=list(label1c=label1c, entry1c=entry1c))
        widgetICLinear <- widget(wTitle=paste(titlename,
                                   paste("Information content ",
                                         substring(titlename2, 1,
                                                   nchar(titlename2)-2),
                                         " variation bounds", sep=""),
                                   sep=""),
                                 pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 2){    
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1=list(label1start=label1start, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line2=list(label2start=label2start, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line3=list(label2end=label2end, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                recall=list(labelRe=labelRe),
                blank2=list(labelB2=labelB2),
                lineErr1=list(label1c=label1c, entry1c=entry1c),
                lineErr2=list(label2c=label2c, entry2c=entry2c))
        widgetICLinear <- widget(wTitle=
                                 paste(titlename,
                                       paste("Information content ",
                                             substring(titlename2, 1,
                                                       nchar(titlename2)-2),
                                             " variation bounds",
                                             sep=""), sep=""),
                                 pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 3){    
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1=list(label1start=label1start, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line2=list(label2start=label2start, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line3=list(label3start=label3start, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                line4=list(label3end=label3end, entry4a=entry4a, label4b=label4b, entry4b=entry4b),
                recall=list(labelRe=labelRe),
                blank2=list(labelB2=labelB2),
                lineErr1=list(label1c=label1c, entry1c=entry1c),
                lineErr2=list(label2c=label2c, entry2c=entry2c),
                lineErr3=list(label3c=label3c, entry3c=entry3c))
        widgetICLinear <- widget(wTitle=paste(titlename,
                                   paste("Information content ",
                                         substring(titlename2, 1,
                                                   nchar(titlename2)-2),
                                         " variation bounds", sep=""),
                                   sep=""),
                                 pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 4){    
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1=list(label1start=label1start, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line2=list(label2start=label2start, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line3=list(label3start=label3start, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                line4=list(label4start=label4start, entry4a=entry4a, label4b=label4b, entry4b=entry4b),
                line5=list(label4end=label4end, entry5a=entry5a, label5b=label5b, entry5b=entry5b),
                recall=list(labelRe=labelRe),
                blank2=list(labelB2=labelB2),
                lineErr1=list(label1c=label1c, entry1c=entry1c),
                lineErr2=list(label2c=label2c, entry2c=entry2c),
                lineErr3=list(label3c=label3c, entry3c=entry3c),
                lineErr4=list(label4c=label4c, entry4c=entry4c))
        widgetICLinear <- widget(wTitle=paste(titlename,
                                   paste("Information content ",
                                         substring(titlename2, 1,
                                                   nchar(titlename2)-2),
                                         " variation bounds", sep=""),
                                   sep=""),
                                 pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 5){    
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1=list(label1start=label1start, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line2=list(label2start=label2start, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line3=list(label3start=label3start, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                line4=list(label4start=label4start, entry4a=entry4a, label4b=label4b, entry4b=entry4b),
                line5=list(label5start=label5start, entry5a=entry5a, label5b=label5b, entry5b=entry5b),
                line6=list(label5end=label5end, entry6a=entry6a, label6b=label6b, entry5b=entry6b),
                recall=list(labelRe=labelRe),
                blank2=list(labelB2=labelB2),
                lineErr1=list(label1c=label1c, entry1c=entry1c),
                lineErr2=list(label2c=label2c, entry2c=entry2c),
                lineErr3=list(label3c=label3c, entry3c=entry3c),
                lineErr4=list(label4c=label4c, entry4c=entry4c),
                lineErr5=list(label5c=label5c, entry5c=entry5c))
        widgetICLinear <- widget(wTitle=paste(titlename,
                                   "Information content linear variation bounds", sep=""),
                                 pWidgets, funs=list(), preFun=function() {},                                 
                                 postFun=function() {}, env=COSMO.ENVIRON)
      }

    widgetICLinear

}

ICLinearNonCont=function(titlename="" , n, sample=FALSE, titlename2="linearly"){
    labelD  <- label(wName="labelD",
                     wValue=paste("The information content is assumed to vary ", titlename2, " across intervals, but is not assumed to be continuous at junctions between intervals.", sep=""), wEnv=COSMO.ENVIRON)
    labelB1 <- label(wName="labelB1", wValue="\n", wEnv=COSMO.ENVIRON)
    label1start <- label(wName="label1s",
                         wValue="At the beginning of interval 1, the information content is contained between:   ", wEnv=COSMO.ENVIRON)
    entry1a <- entryBox(wName="entry1a", wValue=0, wEnv=COSMO.ENVIRON, wWidth=3)
    label1b <- label(wName="label1b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry1b <- entryBox(wName="entry1b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label1end <- label(wName="label1e",
                       wValue="At the end of interval 1, the information content is contained between:            ", wEnv=COSMO.ENVIRON)
    entry1c <- entryBox(wName="entry1c", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label1d <- label(wName="label1b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry1d <- entryBox(wName="entry1d", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label1e <- label(wName="label1e", wValue="The total error allowed across interval 1 is: ", wEnv=COSMO.ENVIRON)
    entry1e <- entryBox(wName="entry1e", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    label2start <- label(wName="label2s",
                         wValue="At the beginning of interval 2, the information content is contained between:   ", wEnv=COSMO.ENVIRON)
    entry2a <- entryBox(wName="entry2a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label2b <- label(wName="label2b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry2b <- entryBox(wName="entry2b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label2end <- label(wName="label2e",
                       wValue="At the end of interval 2, the information content is contained between:            ", wEnv=COSMO.ENVIRON)
    entry2c <- entryBox(wName="entry2c", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label2d <- label(wName="label2b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry2d <- entryBox(wName="entry2d", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label2e <- label(wName="label2e", wValue="The total error allowed across interval 2 is: ", wEnv=COSMO.ENVIRON)
    entry2e <- entryBox(wName="entry2e", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    label3start <- label(wName="label3s",
                         wValue="At the beginning of interval 3, the information content is contained between:   ", wEnv=COSMO.ENVIRON)
    entry3a <- entryBox(wName="entry3a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label3b <- label(wName="label3b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry3b <- entryBox(wName="entry3b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label3end <- label(wName="label3e",
                       wValue="At the end of interval 3, the information content is contained between:            ", wEnv=COSMO.ENVIRON)
    entry3c <- entryBox(wName="entry3c", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label3d <- label(wName="label3b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry3d <- entryBox(wName="entry3d", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label3e <- label(wName="label3e", wValue="The total error allowed across interval 3 is: ", wEnv=COSMO.ENVIRON)
    entry3e <- entryBox(wName="entry3e", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    label4start <- label(wName="label4s",
                         wValue="At the beginning of interval 4, the information content is contained between:   ", wEnv=COSMO.ENVIRON)
    entry4a <- entryBox(wName="entry4a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label4b <- label(wName="label4b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry4b <- entryBox(wName="entry4b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label4end <- label(wName="label4e",
                       wValue="At the end of interval 4, the information content is contained between:            ", wEnv=COSMO.ENVIRON)
    entry4c <- entryBox(wName="entry4c", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label4d <- label(wName="label4b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry4d <- entryBox(wName="entry4d", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label4e <- label(wName="label4e", wValue="The total error allowed across interval 4 is: ", wEnv=COSMO.ENVIRON)
    entry4e <- entryBox(wName="entry4e", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    label5start <- label(wName="label5s",
                         wValue="At the beginning of interval 5, the information content is contained between:   ", wEnv=COSMO.ENVIRON)
    entry5a <- entryBox(wName="entry5a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label5b <- label(wName="label5b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry5b <- entryBox(wName="entry5b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label5end <- label(wName="label5e",
                       wValue="At the end of interval 5, the information content is contained between:            ", wEnv=COSMO.ENVIRON)
    entry5c <- entryBox(wName="entry5c", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label5d <- label(wName="label6b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry5d <- entryBox(wName="entry5d", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label5e <- label(wName="label5e", wValue="The total error allowed across interval 5 is: ", wEnv=COSMO.ENVIRON)
    entry5e <- entryBox(wName="entry5e", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    labelRe <- label(wName="labelRe",
                     wValue="(Recall that the information content is bounded between 0 and 2)", wEnv=COSMO.ENVIRON)
    
    if (n == 1){    
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1a=list(label1start=label1start, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line1b=list(label1end=label1end, entry1c=entry1c, label1d=label1d, entry1d=entry1d),
                line1c=list(label1e=label1e, entry1e=entry1e),
                recall=list(labelRe=labelRe))
        widgetICLinear <-
          widget(wTitle=paste(titlename, paste("Information content ",
                   substring(titlename2, 1, nchar(titlename2)-2),
                   " variation bounds", sep=""), sep=""), pWidgets, funs=list(),
                 preFun=function() {},                 
                 postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 2){    
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1a=list(label1start=label1start, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line1b=list(label1end=label1end, entry1c=entry1c, label1d=label1d, entry1d=entry1d),
                line1c=list(label1e=label1e, entry1e=entry1e),
                line2a=list(label2start=label2start, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line2b=list(label2end=label2end, entry2c=entry2c, label2d=label2d, entry2d=entry2d),
                line2c=list(label2e=label2e, entry2e=entry2e),
                recall=list(labelRe=labelRe))
        widgetICLinear <- widget(wTitle=paste(titlename,
                                   paste("Information content ", substring(titlename2, 1,
                                                                           nchar(titlename2)-2),
                                         " variation bounds", sep=""), sep=""),                                 
                                 pWidgets, funs=list(), preFun=function() {},
                                 
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 3){    
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1a=list(label1start=label1start, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line1b=list(label1end=label1end, entry1c=entry1c, label1d=label1d, entry1d=entry1d),
                line1c=list(label1e=label1e, entry1e=entry1e),
                line2a=list(label2start=label2start, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line2b=list(label2end=label2end, entry2c=entry2c, label2d=label2d, entry2d=entry2d),
                line2c=list(label2e=label2e, entry2e=entry2e),
                line3a=list(label3start=label3start, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                line3b=list(label3end=label3end, entry3c=entry3c, label3d=label3d, entry3d=entry3d),
                line3c=list(label3e=label3e, entry3e=entry3e),
                recall=list(labelRe=labelRe))
        widgetICLinear <- widget(wTitle=paste(titlename,
                                   paste("Information content ",
                                         substring(titlename2, 1,
                                                   nchar(titlename2)-2), " variation bounds", sep=""), sep=""),
                                 pWidgets, funs=list(), preFun=function() {},                                 
                                 postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 4){    
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1a=list(label1start=label1start, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line1b=list(label1end=label1end, entry1c=entry1c, label1d=label1d, entry1d=entry1d),
                line1c=list(label1e=label1e, entry1e=entry1e),
                line2a=list(label2start=label2start, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line2b=list(label2end=label2end, entry2c=entry2c, label2d=label2d, entry2d=entry2d),
                line2c=list(label2e=label2e, entry2e=entry2e),
                line3a=list(label3start=label3start, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                line3b=list(label3end=label3end, entry3c=entry3c, label3d=label3d, entry3d=entry3d),
                line3c=list(label3e=label3e, entry3e=entry3e),
                line4a=list(label4start=label4start, entry4a=entry4a, label4b=label4b, entry4b=entry4b),
                line4b=list(label4end=label4end, entry4c=entry4c, label4d=label4d, entry4d=entry4d),
                line4c=list(label4e=label4e, entry4e=entry4e),
                recall=list(labelRe=labelRe))
        widgetICLinear <- widget(wTitle=
                                 paste(titlename,
                                       paste("Information content ", substring(titlename2, 1,
                                                                               nchar(titlename2)-2),
                                             " variation bounds", sep=""), sep=""),
                                 pWidgets, funs=list(), preFun=function() {},                                 
                                 postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 5){    
        pWidgets <- list(descrip=list(labelD=labelD),
                blank1=list(labelB1=labelB1),
                line1a=list(label1start=label1start, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
                line1b=list(label1end=label1end, entry1c=entry1c, label1d=label1d, entry1d=entry1d),
                line1c=list(label1e=label1e, entry1e=entry1e),
                line2a=list(label2start=label2start, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
                line2b=list(label2end=label2end, entry2c=entry2c, label2d=label2d, entry2d=entry2d),
                line2c=list(label2e=label2e, entry2e=entry2e),
                line3a=list(label3start=label3start, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
                line3b=list(label3end=label3end, entry3c=entry3c, label3d=label3d, entry3d=entry3d),
                line3c=list(label3e=label3e, entry3e=entry3e),
                line4a=list(label4start=label4start, entry4a=entry4a, label4b=label4b, entry4b=entry4b),
                line4b=list(label4end=label4end, entry4c=entry4c, label4d=label4d, entry4d=entry4d),
                line4c=list(label4e=label4e, entry4e=entry4e),
                line5a=list(label5start=label5start, entry5a=entry5a, label5b=label5b, entry5b=entry5b),
                line5b=list(label5end=label5end, entry5c=entry5c, label5d=label5d, entry5d=entry5d),
                line5c=list(label5e=label5e, entry5e=entry5e),
                recall=list(labelRe=labelRe))
        widgetICLinear <- widget(wTitle=paste(titlename,
                                   paste("Information content ", substring(titlename2, 1,
                                                                           nchar(titlename2)-2),
                                         " variation bounds", sep=""), sep=""),
                                 pWidgets, funs=list(), preFun=function() {},                                 
                                 postFun=function() {}, env=COSMO.ENVIRON)
    }

    widgetICLinear

}

nucleotideFreq <- function(titlename="", n, types, values){
    labelD  <- label(wName="labelD", wValue="
Here you can give lower bounds on nucleotide frequencies for certain positions in the     \n
motif. In the nucleotide window, you may enter one of A, C, G, T, GC or AT.                     \n
If you enter 'All' for the position within the interval, the average nucleotide frequency       \n
across that interval must be at least as great as the lower bound you supply.                    ", wEnv=COSMO.ENVIRON)
    label1  <- label(wName="label1", wValue="    Interval 1    ", wEnv=COSMO.ENVIRON)
    label2  <- label(wName="label2", wValue="    Interval 2    ", wEnv=COSMO.ENVIRON)
    label3  <- label(wName="label3", wValue="    Interval 3    ", wEnv=COSMO.ENVIRON)
    label4  <- label(wName="label4", wValue="    Interval 4    ", wEnv=COSMO.ENVIRON)
    label5  <- label(wName="label5", wValue="    Interval 5    ", wEnv=COSMO.ENVIRON)
    labelP  <- label(wName="labelP", wValue="Position:          ", wEnv=COSMO.ENVIRON)
    labelN  <- label(wName="labelN", wValue="Nucleotide:     ", wEnv=COSMO.ENVIRON)
    labelL  <- label(wName="labelL", wValue="Lower bound: ", wEnv=COSMO.ENVIRON)
    labelB  <- label(wName="labelB", wValue="     ", wEnv=COSMO.ENVIRON)
    labelBH  <- label(wName="labelBH", wValue="                 ", wEnv=COSMO.ENVIRON)
    entryP11 <- entryBox(wName="entryP11", wValue="All", wEnv=COSMO.ENVIRON, wWidth=3)
    entryN11 <- entryBox(wName="entryN11", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryL11 <- entryBox(wName="entryL11", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryP12 <- entryBox(wName="entryP12", wValue="All", wEnv=COSMO.ENVIRON, wWidth=3)
    entryN12 <- entryBox(wName="entryN12", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryL12 <- entryBox(wName="entryL12", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryP13 <- entryBox(wName="entryP13", wValue="All", wEnv=COSMO.ENVIRON, wWidth=3)
    entryN13 <- entryBox(wName="entryN13", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryL13 <- entryBox(wName="entryL13", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryP21 <- entryBox(wName="entryP21", wValue="All", wEnv=COSMO.ENVIRON, wWidth=3)
    entryN21 <- entryBox(wName="entryN21", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryL21 <- entryBox(wName="entryL21", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryP22 <- entryBox(wName="entryP22", wValue="All", wEnv=COSMO.ENVIRON, wWidth=3)
    entryN22 <- entryBox(wName="entryN22", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryL22 <- entryBox(wName="entryL22", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryP23 <- entryBox(wName="entryP23", wValue="All", wEnv=COSMO.ENVIRON, wWidth=3)
    entryN23 <- entryBox(wName="entryN23", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryL23 <- entryBox(wName="entryL23", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryP31 <- entryBox(wName="entryP31", wValue="All", wEnv=COSMO.ENVIRON, wWidth=3)
    entryN31 <- entryBox(wName="entryN31", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryL31 <- entryBox(wName="entryL31", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryP32 <- entryBox(wName="entryP32", wValue="All", wEnv=COSMO.ENVIRON, wWidth=3)
    entryN32 <- entryBox(wName="entryN32", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryL32 <- entryBox(wName="entryL32", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryP33 <- entryBox(wName="entryP33", wValue="All", wEnv=COSMO.ENVIRON, wWidth=3)
    entryN33 <- entryBox(wName="entryN33", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryL33 <- entryBox(wName="entryL33", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryP41 <- entryBox(wName="entryP41", wValue="All", wEnv=COSMO.ENVIRON, wWidth=3)
    entryN41 <- entryBox(wName="entryN41", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryL41 <- entryBox(wName="entryL41", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryP42 <- entryBox(wName="entryP42", wValue="All", wEnv=COSMO.ENVIRON, wWidth=3)
    entryN42 <- entryBox(wName="entryN42", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryL42 <- entryBox(wName="entryL42", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryP43 <- entryBox(wName="entryP43", wValue="All", wEnv=COSMO.ENVIRON, wWidth=3)
    entryN43 <- entryBox(wName="entryN43", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryL43 <- entryBox(wName="entryL43", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryP51 <- entryBox(wName="entryP51", wValue="All", wEnv=COSMO.ENVIRON, wWidth=3)
    entryN51 <- entryBox(wName="entryN51", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryL51 <- entryBox(wName="entryL51", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryP52 <- entryBox(wName="entryP52", wValue="All", wEnv=COSMO.ENVIRON, wWidth=3)
    entryN52 <- entryBox(wName="entryN52", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryL52 <- entryBox(wName="entryL52", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryP53 <- entryBox(wName="entryP53", wValue="All", wEnv=COSMO.ENVIRON, wWidth=3)
    entryN53 <- entryBox(wName="entryN53", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    entryL53 <- entryBox(wName="entryL53", wValue="", wEnv=COSMO.ENVIRON, wWidth=3)
    
    if (n == 1){    
        pWidgets <- list(descrip=list(labelD=labelD),
                line1=list(label1=label1),
                line111=list(labelP=labelP, entryP11=entryP11),
                line112=list(labelN=labelN, entryN11=entryN11),
                line113=list(labelL=labelL, entryL11=entryL11),
                line121=list(labelP=labelP, entryP12=entryP12),
                line122=list(labelN=labelN, entryN12=entryN12),
                line123=list(labelL=labelL, entryL12=entryL12),
                line131=list(labelP=labelP, entryP13=entryP13),
                line132=list(labelN=labelN, entryN13=entryN13),
                line133=list(labelL=labelL, entryL13=entryL13))
        widgetNucFreq <- widget(wTitle=paste(titlename,
                                  "Nucleotide Frequency Constraints", sep=""), pWidgets,
                                funs=list(), preFun=function() {},                                
                                postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 2){    
        pWidgets <- list(descrip=list(labelD=labelD),
                line1=list(label1=label1, labelBH=labelBH, label2=label2),
                line111=list(labelP=labelP, entryP11=entryP11, labelB=labelB, labelP=labelP, entryP21=entryP21),
                line112=list(labelN=labelN, entryN11=entryN11, labelB=labelB, labelN=labelN, entryN21=entryN21),
                line113=list(labelL=labelL, entryL11=entryL11, labelB=labelB, labelL=labelL, entryL21=entryL21),
                line121=list(labelP=labelP, entryP12=entryP12, labelB=labelB, labelP=labelP, entryP22=entryP22),
                line122=list(labelN=labelN, entryN12=entryN12, labelB=labelB, labelN=labelN, entryN22=entryN22),
                line123=list(labelL=labelL, entryL12=entryL12, labelB=labelB, labelL=labelL, entryL22=entryL22),
                line131=list(labelP=labelP, entryP13=entryP13, labelB=labelB, labelP=labelP, entryP23=entryP23),
                line132=list(labelN=labelN, entryN13=entryN13, labelB=labelB, labelN=labelN, entryN23=entryN23),
                line133=list(labelL=labelL, entryL13=entryL13, labelB=labelB, labelL=labelL, entryL23=entryL23))
        widgetNucFreq <- widget(wTitle=
                                paste(titlename,
                                      "Nucleotide Frequency Constraints", sep=""),
                                pWidgets, funs=list(), preFun=function() {},                                                                            postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 3){    
        pWidgets <- list(descrip=list(labelD=labelD),
                line1=list(label1=label1, labelBH=labelBH, label2=label2, labelBH=labelBH, label3),
                line111=list(labelP=labelP, entryP11=entryP11,
                  labelB=labelB, labelP=labelP, entryP21=entryP21,
                  labelB=labelB, labelP=labelP, entryP31=entryP31),
                         line112=list(labelN=labelN, entryN11=entryN11,
                           labelB=labelB, labelN=labelN, entryN21=entryN21,
                           labelB=labelB, labelN=labelN, entryN31=entryN31),                         
                         line113=list(labelL=labelL, entryL11=entryL11,
                           labelB=labelB, labelL=labelL, entryL21=entryL21,
                           labelB=labelB, labelL=labelL, entryL31=entryL31),                         
                         line121=list(labelP=labelP, entryP12=entryP12,
                           labelB=labelB, labelP=labelP, entryP22=entryP22,
                           labelB=labelB, labelP=labelP, entryP32=entryP32),                         
                         line122=list(labelN=labelN, entryN12=entryN12,
                           labelB=labelB, labelN=labelN, entryN22=entryN22,
                           labelB=labelB, labelN=labelN, entryN32=entryN32),                         
                         line123=list(labelL=labelL, entryL12=entryL12,
                           labelB=labelB, labelL=labelL, entryL22=entryL22,
                           labelB=labelB, labelL=labelL, entryL32=entryL32),                         
                         line131=list(labelP=labelP, entryP13=entryP13,
                           labelB=labelB, labelP=labelP, entryP23=entryP23,
                           labelB=labelB, labelP=labelP, entryP33=entryP33),                         
                         line132=list(labelN=labelN, entryN13=entryN13,
                           labelB=labelB, labelN=labelN, entryN23=entryN23,
                           labelB=labelB, labelN=labelN, entryN33=entryN33),                         
                         line133=list(labelL=labelL, entryL13=entryL13,
                           labelB=labelB, labelL=labelL, entryL23=entryL23,
                           labelB=labelB, labelL=labelL, entryL33=entryL33))        
        widgetNucFreq <- widget(wTitle=paste(titlename,
                                  "Nucleotide Frequency Constraints",
                                  sep=""),
                                pWidgets, funs=list(), preFun=function() {},
            postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 4){    
        pWidgets <- list(descrip=list(labelD=labelD),
                line1=list(label1=label1, labelBH=labelBH,
                  label2=label2,
                  labelBH=labelBH, label3, labelBH=labelBH, label4),
                         line111=list(labelP=labelP,
                           entryP11=entryP11, labelB=labelB, labelP=labelP,
                           entryP21=entryP21, labelB=labelB, labelP=labelP,
                           entryP31=entryP31, labelB=labelB, labelP=labelP,
                           entryP41=entryP41),                                                  
                         line112=list(labelN=labelN,
                           entryN11=entryN11, labelB=labelB,
                           labelN=labelN, entryN21=entryN21,
                           labelB=labelB, labelN=labelN,
                           entryN31=entryN31, labelB=labelB,
                           labelN=labelN, entryN41=entryN41),                         
                         line113=list(labelL=labelL,
                           entryL11=entryL11, labelB=labelB,
                           labelL=labelL, entryL21=entryL21,
                         labelB=labelB, labelL=labelL,
                           entryL31=entryL31, labelB=labelB,
                           labelL=labelL, entryL41=entryL41),                         
                         line121=list(labelP=labelP, entryP12=entryP12,
                           labelB=labelB, labelP=labelP, entryP22=entryP22,
                           labelB=labelB, labelP=labelP, entryP32=entryP32,
                           labelB=labelB, labelP=labelP, entryP42=entryP42),                         
                         line122=list(labelN=labelN, entryN12=entryN12,
                           labelB=labelB, labelN=labelN, entryN22=entryN22,
                           labelB=labelB, labelN=labelN, entryN32=entryN32,
                           labelB=labelB, labelN=labelN, entryN42=entryN42),                         
                         line123=list(labelL=labelL, entryL12=entryL12,
                           labelB=labelB, labelL=labelL, entryL22=entryL22,
                           labelB=labelB, labelL=labelL, entryL32=entryL32,
                           labelB=labelB, labelL=labelL, entryL42=entryL42),                         
                         line131=list(labelP=labelP, entryP13=entryP13,
                           labelB=labelB, labelP=labelP, entryP23=entryP23,
                           labelB=labelB, labelP=labelP, entryP33=entryP33,
                           labelB=labelB, labelP=labelP, entryP43=entryP43),                         
                         line132=list(labelN=labelN, entryN13=entryN13,
                           labelB=labelB, labelN=labelN, entryN23=entryN23,
                           labelB=labelB, labelN=labelN, entryN33=entryN33,
                           labelB=labelB, labelN=labelN, entryN43=entryN43),                         
                         line133=list(labelL=labelL, entryL13=entryL13,
                           labelB=labelB, labelL=labelL, entryL23=entryL23,
                           labelB=labelB, labelL=labelL, entryL33=entryL33,
                           labelB=labelB, labelL=labelL, entryL43=entryL43))        
        widgetNucFreq <- widget(wTitle=paste(titlename,
                                  "Nucleotide Frequency Constraints",
                                  sep=""),
                                pWidgets, funs=list(), preFun=function() {},
                                postFun=function() {}, env=COSMO.ENVIRON)
    }
    else if (n == 5){    
        pWidgets <- list(descrip=list(labelD=labelD),
                         line1=list(label1=label1, labelBH=labelBH,
                           label2=label2, labelBH=labelBH, label3, labelBH=labelBH,
                           label4, labelBH=labelBH, label5),                         
                         line111=list(labelP=labelP, entryP11=entryP11,
                           labelB=labelB, labelP=labelP, entryP21=entryP21,
                           labelB=labelB, labelP=labelP, entryP31=entryP31,
                           labelB=labelB, labelP=labelP, entryP41=entryP41,
                           labelB=labelB, labelP=labelP, entryP51=entryP51),                         
                         line112=list(labelN=labelN, entryN11=entryN11,
                           labelB=labelB, labelN=labelN, entryN21=entryN21,
                           labelB=labelB, labelN=labelN, entryN31=entryN31,
                           labelB=labelB, labelN=labelN, entryN41=entryN41,
                           labelB=labelB, labelN=labelN, entryN51=entryN51),                         
                         line113=list(labelL=labelL, entryL11=entryL11,
                           labelB=labelB, labelL=labelL, entryL21=entryL21,
                           labelB=labelB, labelL=labelL, entryL31=entryL31,
                           labelB=labelB, labelL=labelL, entryL41=entryL41,
                           labelB=labelB, labelL=labelL, entryL51=entryL51),                         
                         line121=list(labelP=labelP, entryP12=entryP12,
                           labelB=labelB, labelP=labelP, entryP22=entryP22,
                           labelB=labelB, labelP=labelP, entryP32=entryP32,
                           labelB=labelB, labelP=labelP, entryP42=entryP42,
                           labelB=labelB, labelP=labelP, entryP52=entryP52),                         
                         line122=list(labelN=labelN, entryN12=entryN12,
                           labelB=labelB, labelN=labelN, entryN22=entryN22,
                           labelB=labelB, labelN=labelN, entryN32=entryN32,
                           labelB=labelB, labelN=labelN, entryN42=entryN42,
                           labelB=labelB, labelN=labelN, entryN52=entryN52),                         
                         line123=list(labelL=labelL, entryL12=entryL12,
                           labelB=labelB, labelL=labelL, entryL22=entryL22,
                           labelB=labelB, labelL=labelL, entryL32=entryL32,
                           labelB=labelB, labelL=labelL, entryL42=entryL42,
                           labelB=labelB, labelL=labelL, entryL52=entryL52),                         
                         line131=list(labelP=labelP, entryP13=entryP13,
                           labelB=labelB, labelP=labelP, entryP23=entryP23,
                           labelB=labelB, labelP=labelP, entryP33=entryP33,
                           labelB=labelB, labelP=labelP, entryP43=entryP43,
                           labelB=labelB, labelP=labelP, entryP53=entryP53),                         
                         line132=list(labelN=labelN, entryN13=entryN13,
                           labelB=labelB, labelN=labelN, entryN23=entryN23,
                           labelB=labelB, labelN=labelN, entryN33=entryN33,
                           labelB=labelB, labelN=labelN, entryN43=entryN43,
                           labelB=labelB, labelN=labelN, entryN53=entryN53),                         
                         line133=list(labelL=labelL, entryL13=entryL13,
                           labelB=labelB, labelL=labelL, entryL23=entryL23,
                           labelB=labelB, labelL=labelL, entryL33=entryL33,
                           labelB=labelB, labelL=labelL, entryL43=entryL43,
                           labelB=labelB, labelL=labelL, entryL53=entryL53))
        
        widgetNucFreq <- widget(wTitle=paste(titlename,
                                  "Nucleotide Frequency Constraints", sep=""), pWidgets,
                                funs=list(), preFun=function() {},                                
                                postFun=function() {}, env=COSMO.ENVIRON)
    }

    ints <- as.vector(matrix(rep(1:n, 3), ncol=n, byrow=TRUE))
    position <- as.vector(sapply(1:n, function(i){
      c(wValue(pWidgets(widgetNucFreq)[["line111"]][[3*i-1]]),
        wValue(pWidgets(widgetNucFreq)[["line121"]][[3*i-1]]),
        wValue(pWidgets(widgetNucFreq)[["line131"]][[3*i-1]]))}))
        
        if (sum(types[ints[position!="All"]]!="B")>0){
            warning("Nucleotide frequency constraints can only be given at specific positions for intervals of type 'BasePairs' only")
            break}
        
    if(sum(values[ints[position!="All"]]<position[position!="All"])>0){
      warning("Individual position for nucleotide frequency constraint must be equal or less than number of base pairs")
      break}
        
    
    widgetNucFreq

}

sampleICStep <- function(){
    L <- intervalNumAndType()
    n <- L[[1]]
    widgetIntType <- L[[2]]

    widgetICStep <- ICStep(titlename="", n=n, sample=TRUE)

    ## BUILD CONSTRAINT OBJECT

    types <- sapply(1:n, function(i){
      c("B", "P", "V")[wValue(pWidgets(widgetIntType)[[paste("line", i, "a", sep="")]][[2]])]})
    values <- sapply(1:n, function(i){
      ifelse(as.numeric(wValue(pWidgets(widgetIntType)[[paste("line",
                                                              i, "b", sep="")]][[2]]))!=0,
             as.numeric(wValue(pWidgets(widgetIntType)[[paste("line", i, "b",
                                                              sep="")]][[2]])), "Variable")})
    
    sampleConSet <- cosmo::makeConSet(n, types, values)

    constraints <- lapply(1:n, function(i){
      cosmo::makeShapeCon("Linear",
                   as.numeric(wValue(pWidgets(widgetICStep)[[paste("line", i,
                                                                   "a", sep="")]][[2]])),
                   as.numeric(wValue(pWidgets(widgetICStep)[[paste("line", i,
                                                                   "a", sep="")]][[4]])),
                   as.numeric(wValue(pWidgets(widgetICStep)[[paste("line", i,
                                                                   "a", sep="")]][[2]])),
                   as.numeric(wValue(pWidgets(widgetICStep)[[paste("line", i,
                                                                   "a", sep="")]][[4]])),
                   as.numeric(wValue(pWidgets(widgetICStep)[[paste("line", i,
                                                                   "b", sep="")]][[2]])))      
    })

    sampleConSet <- cosmo::addCon(sampleConSet, constraints, 1:n)
    
    if (n>1) {
        if (wValue(pWidgets(widgetICStep)[["radios"]][["radios1"]])[2]){
          palconstraint <-
            cosmo::makePalCon(as.numeric(wValue(pWidgets(widgetICStep)[["palin"]][["entryPa"]])),
                       as.numeric(wValue(pWidgets(widgetICStep)[["palin"]][["entryPb"]])),
                       as.numeric(wValue(pWidgets(widgetICStep)[["palin2"]][["entryPc"]])))          
          sampleConSet <- cosmo::addCon(sampleConSet, list(palconstraint),
                                 1)                        
        }
    }    

    COSMO.CONSTRAINTS <<- sampleConSet
}

sampleICBound <- function(){
    L <- intervalNumAndType()
    n <- L[[1]]
    widgetIntType <- L[[2]]

    widgetICBound <- ICBound(titlename="", n, sample=TRUE)

    ## BUILD CONSTRAINT OBJECT

    types <- sapply(1:n, function(i){
      c("B", "P", "V")[wValue(pWidgets(widgetIntType)[[paste("line", i, "a", sep="")]][[2]])]})
    values <- sapply(1:n, function(i){
      ifelse(as.numeric(wValue(pWidgets(widgetIntType)[[paste("line",
                                                              i, "b", sep="")]][[2]]))!=0,
             as.numeric(wValue(pWidgets(widgetIntType)[[paste("line", i, "b",
                                                              sep="")]][[2]])), "Variable")})
    
    sampleConSet <- cosmo::makeConSet(n, types, values)

    constraints <- lapply(1:n, function(i){
      cosmo::makeBoundCon(as.numeric(wValue(pWidgets(widgetICBound)[[paste("line", i, sep="")]][[2]])),
                   as.numeric(wValue(pWidgets(widgetICBound)[[paste("line", i, sep="")]][[4]])))
        
    })

    sampleConSet <- cosmo::addCon(sampleConSet, constraints, 1:n)
    
    if (wValue(pWidgets(widgetICBound)[["radios"]][["radios1"]])[2]){
        palconstraint <-
          cosmo::makePalCon(as.numeric(wValue(pWidgets(widgetICBound)[["palin"]][["entryPa"]])),
                     as.numeric(wValue(pWidgets(widgetICBound)[["palin"]][["entryPb"]])),
                     as.numeric(wValue(pWidgets(widgetICBound)[["palin2"]][["entryPc"]])))
        
        sampleConSet <- cosmo::addCon(sampleConSet, list(palconstraint), 1)
    }    

    COSMO.CONSTRAINTS <<- sampleConSet
}

sampleV <- function(){
    n <- 2

    labelD  <- label(wName="labelD",
                     wValue="The information content is assumed to follow a linear, continuous and symetric high-low-high pattern.", wEnv=COSMO.ENVIRON)
    labelB1 <- label(wName="labelB1", wValue="\n", wEnv=COSMO.ENVIRON)
    label1a <- label(wName="label1a",
                     wValue="At the beginning of the first interval, the information content is contained between:                                 ", wEnv=COSMO.ENVIRON)
    entry1a <- entryBox(wName="entry1a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label1b <- label(wName="label1b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry1b <- entryBox(wName="entry1b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label2a <- label(wName="label2a",
                     wValue="At the end of the first interval (beginning of the second), the information content is contained between: ", wEnv=COSMO.ENVIRON)
    entry2a <- entryBox(wName="entry2a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label2b <- label(wName="label2b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry2b <- entryBox(wName="entry2b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label3a <- label(wName="label3a",
                     wValue="At the end of the second interval, the information content is contained between:                                    ", wEnv=COSMO.ENVIRON)
    entry3a <- entryBox(wName="entry3a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label3b <- label(wName="label3b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry3b <- entryBox(wName="entry3b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    labelErr1 <- label(wName="labelErr1",
                       wValue="The information content profile across interval 1 may deviate from a linear function by at most: ", wEnv=COSMO.ENVIRON)
    entryErr1 <- entryBox(wName="entryErr1", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    labelErr2 <- label(wName="labelErr2", wValue="The information content profile across interval 2 may deviate from a linear function by at most: ", wEnv=COSMO.ENVIRON)
    entryErr2 <- entryBox(wName="entryErr2", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    labelRe <- label(wName="labelRe",
                     wValue="(Recall that the information content is bounded between 0 and 2)", wEnv=COSMO.ENVIRON)
    labelB2  <- label(wName="labelB2", wValue="\n \n", wEnv=COSMO.ENVIRON)
    labelR  <- label(wName="labelR", wValue="Are there palindromic intervals?", wEnv=COSMO.ENVIRON)
    radios1 <- radioButton(wName="radios1", wValue=c(No=TRUE, Yes=FALSE), wEnv=COSMO.ENVIRON)
    labelPa <- label(wName="labelPa", wValue="(If Yes) Which intervals are palindromic?", wEnv=COSMO.ENVIRON)
    entryPa <- entryBox(wName="entryPa", wValue="1", wEnv=COSMO.ENVIRON, wWidth=3)
    labelPb <- label(wName="labelPb", wValue=" and ", wEnv=COSMO.ENVIRON)
    entryPb <- entryBox(wName="entryPb", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    labelPc <- label(wName="labelPc",
                     wValue="(If Yes) Corresponding nucleotide frequencies may deviate \n from each other by at most this proportion (between 0 and 1):", wEnv=COSMO.ENVIRON)
    entryPc <- entryBox(wName="entryPc", wValue="?", wEnv=COSMO.ENVIRON, wWidth=4)
        
    pWidgets <- list(descrip=list(labelD=labelD),
            blank1=list(labelB1=labelB1),
            line1=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
            line2=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
            line3=list(label3a=label3a, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
            recall=list(labelRe=labelRe),
            line4=list(labelErr1=labelErr1, entryErr1=entryErr1),
            line5=list(labelErr2=labelErr2, entryErr2=entryErr2),
            blank2=list(labelB2=labelB2),
            radios=list(labelR=labelR, radios1=radios1),
            palin=list(labelPa=labelPa, entryPa=entryPa, labelPb=labelPb, entryPb=entryPb),
            palin2=list(labelPc=labelPc, entryPc=entryPc))
    widgetV <- widget(wTitle="V-shaped information content bounds",
                      pWidgets, funs=list(), preFun=function() {},
        postFun <- function() {}, env=COSMO.ENVIRON)

    ## BUILD CONSTRAINT OBJECT

    types <- c("V", "V")
    values <- c(50, 50)
    sampleConSet <- cosmo::makeConSet(n, types, values)

    constraints <- lapply(1:n, function(i){
      cosmo::makeShapeCon("Linear",
                   as.numeric(wValue(pWidgets(widgetV)[[paste("line", i,
                                                              sep="")]][[2]])),
                   as.numeric(wValue(pWidgets(widgetV)[[paste("line", i,
                                                              sep="")]][[4]])),
                   as.numeric(wValue(pWidgets(widgetV)[[paste("line", i+1,
                                                              sep="")]][[2]])),
                   as.numeric(wValue(pWidgets(widgetV)[[paste("line", i+1,
                                                              sep="")]][[4]])),
                   as.numeric(wValue(pWidgets(widgetV)[[paste("line", i+3,
                                                              sep="")]][[2]])))
      
    })
    sampleConSet <- cosmo::addCon(sampleConSet, constraints, 1:n)
    
    SD1 <- cosmo::makeShapeDiffCon("1b", "2a", 0, 0)
    SD2 <- cosmo::makeShapeDiffCon("1a", "2b", 0, 0)
    sampleConSet <- cosmo::addCon(sampleConSet, list(SD1, SD2), c(1, 1))
    
    if (wValue(pWidgets(widgetV)[["radios"]][["radios1"]])[2]){
      palconstraint <-
        cosmo::makePalCon(as.numeric(wValue(pWidgets(widgetV)[["palin"]][["entryPa"]])),
                   as.numeric(wValue(pWidgets(widgetV)[["palin"]][["entryPb"]])),
                   as.numeric(wValue(pWidgets(widgetV)[["palin2"]][["entryPc"]])))
      
      sampleConSet <- cosmo::addCon(sampleConSet, list(palconstraint), 1)
    }

    COSMO.CONSTRAINTS <<- sampleConSet

}

sampleA <- function(){
    n <- 2    

    labelD  <- label(wName="labelD",
                     wValue="The information content is assumed to follow a linear, continuous and symetric low-high-low pattern.", wEnv=COSMO.ENVIRON)
    labelB1 <- label(wName="labelB1", wValue="\n", wEnv=COSMO.ENVIRON)
    label1a <- label(wName="label1a",
                     wValue="At the beginning of the first interval, the information content is contained between:                                 ", wEnv=COSMO.ENVIRON)
    entry1a <- entryBox(wName="entry1a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label1b <- label(wName="label1b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry1b <- entryBox(wName="entry1b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label2a <- label(wName="label2a",
                     wValue="At the end of the first interval (beginning of the second), the information content is contained between: ", wEnv=COSMO.ENVIRON)
    entry2a <- entryBox(wName="entry2a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label2b <- label(wName="label2b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry2b <- entryBox(wName="entry2b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    label3a <- label(wName="label3a",
                     wValue="At the end of the second interval, the information content is contained between:                                    ", wEnv=COSMO.ENVIRON)
    entry3a <- entryBox(wName="entry3a", wValue="0", wEnv=COSMO.ENVIRON, wWidth=3)
    label3b <- label(wName="label3b", wValue=" and ", wEnv=COSMO.ENVIRON)
    entry3b <- entryBox(wName="entry3b", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    labelErr1 <- label(wName="labelErr1",
                       wValue="The information content profile across interval 1 may deviate from a linear function by at most: ", wEnv=COSMO.ENVIRON)
    entryErr1 <- entryBox(wName="entryErr1", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    labelErr2 <- label(wName="labelErr2",
                       wValue="The information content profile across interval 2 may deviate from a linear function by at most: ", wEnv=COSMO.ENVIRON)
    entryErr2 <- entryBox(wName="entryErr2", wValue="0.05", wEnv=COSMO.ENVIRON, wWidth=4)
    labelRe <- label(wName="labelRe",
                     wValue="(Recall that the information content is bounded between 0 and 2)", wEnv=COSMO.ENVIRON)
    labelB2  <- label(wName="labelB2", wValue="\n \n", wEnv=COSMO.ENVIRON)
    labelR  <- label(wName="labelR", wValue="Are there palindromic intervals?", wEnv=COSMO.ENVIRON)
    radios1 <- radioButton(wName="radios1", wValue=c(No=TRUE, Yes=FALSE), wEnv=COSMO.ENVIRON)
    labelPa <- label(wName="labelPa", wValue="(If Yes) Which intervals are palindromic?", wEnv=COSMO.ENVIRON)
    entryPa <- entryBox(wName="entryPa", wValue="1", wEnv=COSMO.ENVIRON, wWidth=3)
    labelPb <- label(wName="labelPb", wValue=" and ", wEnv=COSMO.ENVIRON)
    entryPb <- entryBox(wName="entryPb", wValue="2", wEnv=COSMO.ENVIRON, wWidth=3)
    labelPc <- label(wName="labelPc",
                     wValue="(If Yes) Corresponding nucleotide frequencies may deviate \n from each other by at most this proportion (between 0 and 1):", wEnv=COSMO.ENVIRON)
    entryPc <- entryBox(wName="entryPc", wValue="?", wEnv=COSMO.ENVIRON, wWidth=4)
        
    pWidgets <- list(descrip=list(labelD=labelD),
            blank1=list(labelB1=labelB1),
            line1=list(label1a=label1a, entry1a=entry1a, label1b=label1b, entry1b=entry1b),
            line2=list(label2a=label2a, entry2a=entry2a, label2b=label2b, entry2b=entry2b),
            line3=list(label3a=label3a, entry3a=entry3a, label3b=label3b, entry3b=entry3b),
            recall=list(labelRe=labelRe),
            line4=list(labelErr1=labelErr1, entryErr1=entryErr1),
            line5=list(labelErr2=labelErr2, entryErr2=entryErr2),
            blank2=list(labelB2=labelB2),
            radios=list(labelR=labelR, radios1=radios1),
            palin=list(labelPa=labelPa, entryPa=entryPa, labelPb=labelPb, entryPb=entryPb),
            palin2=list(labelPc=labelPc, entryPc=entryPc))
    widgetA <- widget(wTitle="A-shaped information content bounds",
                      pWidgets, funs=list(), preFun=function() {},
                      postFun=function() {}, env=COSMO.ENVIRON)
    
    ## BUILD CONSTRAINT OBJECT

    types <- c("V", "V")
    values <- c(50, 50)
    sampleConSet <- cosmo::makeConSet(n, types, values)

    constraints <- lapply(1:n, function(i){
      cosmo::makeShapeCon("Linear",
                   as.numeric(wValue(pWidgets(widgetA)[[paste("line", i,
                                                              sep="")]][[2]])),
                   as.numeric(wValue(pWidgets(widgetA)[[paste("line", i,
                                                              sep="")]][[4]])),
                   as.numeric(wValue(pWidgets(widgetA)[[paste("line", i+1,
                                                              sep="")]][[2]])),
                   as.numeric(wValue(pWidgets(widgetA)[[paste("line", i+1,
                                                              sep="")]][[4]])),
                   as.numeric(wValue(pWidgets(widgetA)[[paste("line", i+3,
                                                              sep="")]][[2]])))
      
    })
    sampleConSet <- cosmo::addCon(sampleConSet, constraints, 1:n)
    
    SD1 <- cosmo::makeShapeDiffCon("1b", "2a", 0, 0)
    SD2 <- cosmo::makeShapeDiffCon("1a", "2b", 0, 0)
    sampleConSet <- cosmo::addCon(sampleConSet, list(SD1, SD2), c(1, 1))
    
    if (wValue(pWidgets(widgetA)[["radios"]][["radios1"]])[2]){
      palconstraint <-
        cosmo::makePalCon(as.numeric(wValue(pWidgets(widgetA)[["palin"]][["entryPa"]])),
                   as.numeric(wValue(pWidgets(widgetA)[["palin"]][["entryPb"]])),
                   as.numeric(wValue(pWidgets(widgetA)[["palin2"]][["entryPc"]])))      
        sampleConSet <- cosmo::addCon(sampleConSet, list(palconstraint), 1)
    }    

    COSMO.CONSTRAINTS <<- sampleConSet

}

subMotif <- function(sample=TRUE){
    labelD1 <- label(wName="labelD",
                     wValue="The motif is known to contain a shorter concensus sequence.", wEnv=COSMO.ENVIRON)
    label1  <- label(wName="label1a",
                     wValue="The motif contains the following submotif: ", wEnv=COSMO.ENVIRON)
    entry1  <- entryBox(wName="entry1a", wValue="MOTIF", wEnv=COSMO.ENVIRON, wWidth=6)
    label2  <- label(wName="label2a", wValue="with cut-off value: ", wEnv=COSMO.ENVIRON)
    entry2  <- entryBox(wName="entry2a", wValue="0.75", wEnv=COSMO.ENVIRON, wWidth=6)
    labelB  <- label(wName="labelR", wValue="\n", wEnv=COSMO.ENVIRON)
    labelD2 <- label(wName="labelD",
                     wValue="The cut-off value (between 0 and 1) roughly gives the \n minimum frequency with which each of the nucleotides \n in the submotif have to occur within the motif.", wEnv=COSMO.ENVIRON)
    
    pWidgets <- list(descrip1=list(labelD1=labelD1),
            line1=list(label1=label1, entry1=entry1),
            line2=list(label2=label2, entry2=entry2),
            blank=list(labelB=labelB),
            descrip2=list(labelD2=labelD2))
    widgetSubMotif <- widget(wTitle="Submotif Constraint",
                             pWidgets, funs=list(), preFun=function() {},
                             postFun=function() {}, env=COSMO.ENVIRON)

    ## IF SAMPLE == TRUE, BUILD SAMPLE CONSTRAINT OBJECT

    if (sample){
        sampleConSet <- cosmo::makeConSet(1, "V", "Variable")

        constraints <-
          cosmo::makeSubMotifCon(wValue(pWidgets(widgetSubMotif)[[2]][[2]]),
                          as.numeric(wValue(pWidgets(widgetSubMotif)[[3]][[2]])))
        

        sampleConSet <- cosmo::addCon(sampleConSet, list(constraints), 1)
        COSMO.CONSTRAINTS <<- sampleConSet
    }

    widgetSubMotif

}

advancedBuild <- function(){

    ##Step 1
    L <- intervalNumAndType(titlename="Step 1: ")
    n <- L[[1]]
    widgetIntType <- L[[2]]

    ##Step 2
    labelR  <- label(wName="labelR",
                     wValue="Are there palindromic intervals?", wEnv=COSMO.ENVIRON)
    radios1 <- radioButton(wName="radios1", wValue=c(No=TRUE, Yes=FALSE), wEnv=COSMO.ENVIRON)
    labelPa <- label(wName="labelPa",
                     wValue="(If Yes) Which intervals are palindromic?", wEnv=COSMO.ENVIRON)
    entryPa <- entryBox(wName="entryPa", wValue="?", wEnv=COSMO.ENVIRON, wWidth=3)
    labelPb <- label(wName="labelPb", wValue=" and ", wEnv=COSMO.ENVIRON)
    entryPb <- entryBox(wName="entryPb", wValue="?", wEnv=COSMO.ENVIRON, wWidth=3)
    labelPc <- label(wName="labelPc",
                     wValue="(If Yes) Corresponding nucleotide frequencies may deviate \n from each other by at most this proportion (between 0 and 1):", wEnv=COSMO.ENVIRON)
    entryPc <- entryBox(wName="entryPc", wValue="?", wEnv=COSMO.ENVIRON, wWidth=4)    
    pWidgets <- list(radios=list(labelR=labelR, radios1=radios1),
            palin=list(labelPa=labelPa, entryPa=entryPa, labelPb=labelPb, entryPb=entryPb),
            palin2=list(labelPc=labelPc, entryPc=entryPc))
    widgetPal <- widget(
                        wTitle="Step 2: Palindromic Intervals",
                        pWidgets, funs=list(), preFun=function() {},                        
                        postFun=function() {}, env=COSMO.ENVIRON)

    ##Step 3
    labelD  <- label(wName="labelD",
                     wValue="The information content across each interval is:", wEnv=COSMO.ENVIRON)
    radios1 <- radioButton(wName="radios1",
                           wValue=c(Constant=FALSE, Bounded=FALSE,
                             Linear=FALSE, Monotone=FALSE,
                             Unconstrained=TRUE), wEnv=COSMO.ENVIRON)
    pWidgets <- list(descrip=list(labelD=labelD), radios=list(radios1=radios1))
    widgetICvary <-
      widget(wTitle="Step 3: Information content variation",
             pWidgets, funs=list(), preFun=function() {},
             postFun=function() {}, env=COSMO.ENVIRON)
    
    if (wValue(pWidgets(widgetICvary)[["radios"]][["radios1"]])[1]){
        widgetICStep <- ICStep(titlename="Step 3: ", n, sample=FALSE)
    }
    else if(wValue(pWidgets(widgetICvary)[["radios"]][["radios1"]])[2]){
        widgetICBound <- ICBound(titlename="Step 3: ", n)    
    }
    else if(wValue(pWidgets(widgetICvary)[["radios"]][["radios1"]])[3]){
        labelD  <- label(wName="labelD",
                         wValue="Is the information content continuous at junctions between intervals?",
                         wEnv=COSMO.ENVIRON)
        radios1 <- radioButton(wName="radios1", wValue=c(Yes=TRUE, No=FALSE), wEnv=COSMO.ENVIRON)
        pWidgets <- list(descrip=list(labelD=labelD), radios=list(radios1=radios1))
        widgetCont <-
          widget(wTitle="Step 3: Information content continuity",
                 pWidgets, funs=list(), preFun=function() {},
                 postFun=function() {}, env=COSMO.ENVIRON)
        cont <- wValue(pWidgets(widgetCont)[["radios"]][["radios1"]])[1]
        if (cont){
            widgetICLinear <- ICLinearCont(titlename="Step 3: ", n, sample=FALSE)
        }
        else {
            widgetICLinear <- ICLinearNonCont(titlename="Step 3: ", n, sample=FALSE)
        }
    }
    else if(wValue(pWidgets(widgetICvary)[["radios"]][["radios1"]])[4]){
        labelD  <- label(wName="labelD",
                         wValue="Is the information content continuous at junctions between intervals?",
                         wEnv=COSMO.ENVIRON)
        radios1 <- radioButton(wName="radios1", wValue=c(Yes=TRUE, No=FALSE), wEnv=COSMO.ENVIRON)
        pWidgets <- list(descrip=list(labelD=labelD), radios=list(radios1=radios1))
        widgetCont <-
          widget(wTitle="Step 3: Information content continuity",
                 pWidgets, funs=list(), preFun=function() {},                 
                 postFun=function() {}, env=COSMO.ENVIRON)
        cont <- wValue(pWidgets(widgetCont)[["radios"]][["radios1"]])[1]
        if (cont){
            widgetICLinear <- ICLinearCont(titlename="Step 3: ", n,
                                           sample=FALSE, titlename2="monotonely")            
        }
        else {
            widgetICLinear <- ICLinearNonCont(titlename="Step 3: ", n,
                                              sample=FALSE, titlename2="monotonely")            
        }
    }
    
    ##Step 4
    types <- sapply(1:n, function(i){
      c("B", "P", "V")[wValue(pWidgets(widgetIntType)[[paste("line", i, "a", sep="")]][[2]])]})
    values <- sapply(1:n,
                     function(i){ifelse(as.numeric(wValue(pWidgets(widgetIntType)[[paste("line", i, "b",
                                                                                         sep="")]][[2]]))!=0,
                                        as.numeric(wValue(pWidgets(widgetIntType)[[paste("line", i, "b", sep="")]][[2]])),
                                        "Variable")})
    
    widgetNucFreq <- nucleotideFreq(titlename="Step 4: ", n, types, values)

    ##Step 5
    widgetSubMotif <- subMotif(sample=FALSE)

    ## BUILD CONSTRAINT OBJECT

    types <- sapply(1:n, function(i){c("B", "P",
                                       "V")[wValue(pWidgets(widgetIntType)[[paste("line", i, "a",
                                                                                  sep="")]][[2]])]})
    values <- sapply(1:n,
                     function(i){ifelse(as.numeric(wValue(pWidgets(widgetIntType)[[paste("line", i, "b",
                                                                                         sep="")]][[2]]))!=0,
                                        as.numeric(wValue(pWidgets(widgetIntType)[[paste("line", i, "b",
                                                                                         sep="")]][[2]])), "Variable")})
    
    advConSet <- cosmo::makeConSet(n, types, values)

    if (wValue(pWidgets(widgetPal)[["radios"]][["radios1"]])[2]){
        palconstraint <-
          cosmo::makePalCon(as.numeric(wValue(pWidgets(widgetPal)[["palin"]][["entryPa"]])),
                     as.numeric(wValue(pWidgets(widgetPal)[["palin"]][["entryPb"]])),
                     as.numeric(wValue(pWidgets(widgetPal)[["palin2"]][["entryPc"]])))
        advConSet <- cosmo::addCon(advConSet, list(palconstraint), 1)
    }
    
    if (wValue(pWidgets(widgetICvary)[["radios"]][["radios1"]])[1]){
        constraints <- lapply(1:n, function(i){
          cosmo::makeShapeCon("Linear",
                       as.numeric(wValue(pWidgets(widgetICStep)[[paste("line", i,
                                                                       "a", sep="")]][[2]])),
                       as.numeric(wValue(pWidgets(widgetICStep)[[paste("line", i,
                                                                       "a", sep="")]][[4]])),
                       as.numeric(wValue(pWidgets(widgetICStep)[[paste("line", i,
                                                                       "a", sep="")]][[2]])),
                       as.numeric(wValue(pWidgets(widgetICStep)[[paste("line", i,
                                                                       "a", sep="")]][[4]])),
                       as.numeric(wValue(pWidgets(widgetICStep)[[paste("line", i,
                                                                       "b", sep="")]][[2]])))
          
        })
        advConSet <- cosmo::addCon(advConSet, constraints, 1:n)
    }
    else if(wValue(pWidgets(widgetICvary)[["radios"]][["radios1"]])[2]){
      constraints <- lapply(1:n, function(i){
        cosmo::makeBoundCon(as.numeric(wValue(pWidgets(widgetICBound)[[paste("line", i, sep="")]][[2]])),
                     as.numeric(wValue(pWidgets(widgetICBound)[[paste("line", i, sep="")]][[4]])))          
        })
        advConSet <- cosmo::addCon(advConSet, constraints, 1:n)        
    }
    else if(wValue(pWidgets(widgetICvary)[["radios"]][["radios1"]])[3]){
        if (cont){
            constraints <- lapply(1:n, function(i){
              cosmo::makeShapeCon("Linear",
                           as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i,
                                                                             sep="")]][[2]])),
                           as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i,
                                                                             sep="")]][[4]])),
                           as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i+1,
                                                                             sep="")]][[2]])),
                           as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i+1,
                                                                             sep="")]][[4]])),
                           as.numeric(wValue(pWidgets(widgetICLinear)[[paste("lineErr",
                                                                             i, sep="")]][[2]])))              
            })
            advConSet <- cosmo::addCon(advConSet, constraints, 1:n)
            constraints <- lapply(1:(n-1), function(i){
                cosmo::makeShapeDiffCon(paste(i, "b", sep=""), paste(i+1, "a", sep=""), 0, 0)
            })
            advConSet <- cosmo::addCon(advConSet, constraints, rep(1, n-1))
        }
        else {
            constraints <- lapply(1:n, function(i){
              cosmo::makeShapeCon("Linear",
                           as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i,
                                                                             "a", sep="")]][[2]])),
                           as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i,
                                                                             "a", sep="")]][[4]])),
                           as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i,
                                                                             "b", sep="")]][[2]])),
                           as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i,
                                                                             "b", sep="")]][[4]])),
                           as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i,
                                                                             "c", sep="")]][[2]])))              
            })
            advConSet <- cosmo::addCon(advConSet, constraints, 1:n)
        }
    }
    else if(wValue(pWidgets(widgetICvary)[["radios"]][["radios1"]])[4]){
        if (cont){
            constraints <- lapply(1:n, function(i){
                sl <- as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i, sep="")]][[2]]))
                su <- as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i, sep="")]][[2]]))
                el <- as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i+1, sep="")]][[2]]))
                eu <- as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i+1, sep="")]][[2]]))
                if ((sl>el & su>=eu) | (sl>=el & su>eu)){
                    variation <-"Monotone Decreasing"
                }
                else if ((sl<el & su<=eu) | (sl<=el & su<eu)){
                    variation <-"Monotone Increasing"    
                }
                else {
                    variation <-"Linear"    
                }
                cosmo::makeShapeCon(variation,
                             as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i,
                                                                               sep="")]][[2]])),
                             as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i,
                                                                               sep="")]][[4]])),
                             as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i+1,
                                                                               sep="")]][[2]])),
                             as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i+1,
                                                                               sep="")]][[4]])),
                             as.numeric(wValue(pWidgets(widgetICLinear)[[paste("lineErr",
                                                                               i, sep="")]][[2]])))
                
            })
            advConSet <- cosmo::addCon(advConSet, constraints, 1:n)
            constraints <- lapply(1:(n-1), function(i){
                cosmo::makeShapeDiffCon(paste(i, "b", sep=""), paste(i+1, "a", sep=""), 0, 0)
            })
            advConSet <- cosmo::addCon(advConSet, constraints, rep(1, n-1))
        }
        else {
            constraints <- lapply(1:n, function(i){
                sl <- as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i, "a", sep="")]][[2]]))
                su <- as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i, "a", sep="")]][[4]]))
                el <- as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i, "b", sep="")]][[2]]))
                eu <- as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i, "b", sep="")]][[4]]))
                if ((sl>el & su>=eu) | (sl>=el & su>eu)){
                    variation <-"Monotone Decreasing"
                }
                else if ((sl<el & su<=eu) | (sl<=el & su<eu)){
                    variation <-"Monotone Increasing"    
                }
                else {
                    variation <-"Linear"    
                }
                cosmo::makeShapeCon(variation,
                             as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line", i,
                                                                               "a", sep="")]][[2]])),
                             as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line",
                                                                               i, "a", sep="")]][[4]])),
                             as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line",
                                                                               i, "b", sep="")]][[2]])),
                             as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line",
                                                                               i, "b", sep="")]][[4]])),
                             as.numeric(wValue(pWidgets(widgetICLinear)[[paste("line",
                                                                               i, "c", sep="")]][[2]])))
                
              })
            advConSet <- cosmo::addCon(advConSet, constraints, 1:n)
        }
    }

    ints <- as.vector(matrix(rep(1:n, 3), ncol=n, byrow=TRUE))
    position <- as.vector(sapply(1:n,
                                 function(i){c(wValue(pWidgets(widgetNucFreq)[["line111"]][[3*i-1]]),
                                               wValue(pWidgets(widgetNucFreq)[["line121"]][[3*i-1]]),
                                               wValue(pWidgets(widgetNucFreq)[["line131"]][[3*i-1]]))}))
    
    nucleo <- as.vector(sapply(1:n,
                               function(i){c(wValue(pWidgets(widgetNucFreq)[["line112"]][[3*i-1]]),
                                             wValue(pWidgets(widgetNucFreq)[["line122"]][[3*i-1]]),
                                             wValue(pWidgets(widgetNucFreq)[["line132"]][[3*i-1]]))}))
    
    lower <- as.vector(sapply(1:n,
                              function(i){c(wValue(pWidgets(widgetNucFreq)[["line113"]][[3*i-1]]),
                                            wValue(pWidgets(widgetNucFreq)[["line123"]][[3*i-1]]),
                                            wValue(pWidgets(widgetNucFreq)[["line133"]][[3*i-1]]))}))
    
    d <- data.frame(ints, position, nucleo, lower)
    d <- d[d[, 3]!="",]
    if (nrow(d)!=0){
        constraints <- lapply(1:nrow(d), function(i){
            cosmo::makePosFreqCon(as.character(d[i, 2]), as.character(d[i, 3]), as.numeric(as.character(d[i, 4])))
        })
        advConSet <- cosmo::addCon(advConSet, constraints, as.numeric(as.character(d[, 1])))
    }
    
    if (wValue(pWidgets(widgetSubMotif)[[2]][[2]])!="MOTIF"){
        constraints <-
          cosmo::makeSubMotifCon(wValue(pWidgets(widgetSubMotif)[["line1"]][[2]]),
                          as.numeric(wValue(pWidgets(widgetSubMotif)[["line2"]][[2]])))
        
        advConSet <- cosmo::addCon(advConSet, list(constraints), 1)
    }
    
    COSMO.CONSTRAINTS <<- advConSet
}

mysample <- function(){
  
    label1 <- label(wName="Sample", wValue="Select a sample constraint:", wEnv=COSMO.ENVIRON)
    button1 <- button(wName="button1", wValue="Step function \n", wFuns=list(command=sampleICStep), wEnv=COSMO.ENVIRON, wWidth=16)
    button2 <- button(wName="button2", wValue="IC bounds \n", wFuns=list(command=sampleICBound), wEnv=COSMO.ENVIRON, wWidth=16)
    button3 <- button(wName="button3", wValue="V-shaped \n", wFuns=list(command=sampleV), wEnv=COSMO.ENVIRON, wWidth=16)
    button4 <- button(wName="button4", wValue="A-shaped \n", wFuns=list(command=sampleA), wEnv=COSMO.ENVIRON, wWidth=16)
    button5 <- button(wName="button5", wValue="Submotif \n", wFuns=list(command=subMotif), wEnv=COSMO.ENVIRON, wWidth=16)
    button6 <- button(wName="button6",
                      wValue="Build from scratch \n (advanced users)",
                      wFuns=list(command=advanced), wEnv=COSMO.ENVIRON, wWidth=16)
    pWidgets <- list(A=list(label1=label1),
                     B=list(button1=button1, button2=button2),
                     C=list(button3=button3, button4=button4),
                     D=list(button5=button5, button6=button6))
    if (interactive()) {

      COSMO.WIDGET <<- widget(wTitle="Constraint Builder: Samples", pWidgets, funs=list(), preFun=function() {},
                         postFun=function() {}, env=COSMO.ENVIRON)
    }
    ##builtConstraintSet <- COSMO.CONSTRAINTS    
}

advanced <- function(){
    label1 <- label(wName="Sample",
                    wValue="These are the five steps you will be taken through to build the constraint set:", wEnv=COSMO.ENVIRON)
    label2 <- label(wName="Sample", wValue="1) Interval setup                 ", wEnv=COSMO.ENVIRON)
    label3 <- label(wName="Sample", wValue="2) Palindromic intervals       ", wEnv=COSMO.ENVIRON)
    label4 <- label(wName="Sample", wValue="3) Information content        ", wEnv=COSMO.ENVIRON)
    label5 <- label(wName="Sample", wValue="4) Nucleotide frequencies  ", wEnv=COSMO.ENVIRON)
    label6 <- label(wName="Sample", wValue="5) Submotif                        ", wEnv=COSMO.ENVIRON)
    label7 <- label(wName="Sample", wValue="", wEnv=COSMO.ENVIRON)
    label8 <- label(wName="Sample",
                    wValue="You need not provide answers at each step: to skip a step, \n simply click 'Finish' on the appropriate pop-up.                       ", wEnv=COSMO.ENVIRON)
    button1 <- button(wName="button1",
                      wValue="Start building constraint set",
                      wFuns=list(command=advancedBuild), wEnv=COSMO.ENVIRON, wWidth=30)
    button2 <- button(wName="button2",
                      wValue="Build from sample constraint set",
                      wFuns=list(command=mysample), wEnv=COSMO.ENVIRON, wWidth=30)
    pWidgets <- list(A1=list(label1=label1), A2=list(label2=label2),
                     A3=list(label3=label3),
                     A4=list(label4=label4), A5=list(label5=label5),
                     A6=list(label6=label6),
                     A7=list(label7=label7), A8=list(label8=label8),
                     B=list(button1=button1), C=list(button2=button2))
    if (interactive()) {

      COSMO.WIDGET <<-
          widget(wTitle="Constraint Builder: Building from scratch",
                 pWidgets, funs=list(), preFun=function() {},
                 postFun=function() {}, env=COSMO.ENVIRON)
      }
}


#####################################
### Main Function: Constraint Builder
#####################################

constraintBuilder <- function() {

  ## remove global variable COSMO.CONSTRAINTS on exit
  on.exit(rm(COSMO.CONSTRAINTS,pos=1))

  COSMO.CONSTRAINTS <<- NULL

  ##First
  label1 <- label(wName="Type of Constraints",
                  wValue="Do you wish to construct a constraint set?", wEnv=COSMO.ENVIRON)
  radios1 <- radioButton(wName="radios1", wValue=c(No=TRUE, Yes=FALSE), wEnv=COSMO.ENVIRON)
  pWidgets <- list(A=list(labels1=label1), B=list(radios1=radios1))
  if (interactive()) {
    COSMO.WIDGET <- widget(wTitle="Constraint Builder", pWidgets, funs=list(), preFun=function() {},
                           postFun=function() {}, env=COSMO.ENVIRON)
  }
  
  if (wValue(pWidgets(COSMO.WIDGET)[["B"]][["radios1"]])[2]) {
    
    ##Second
    label1 <- label(wName="how to build",
                    wValue="How do you wish to build the constraint set?", wEnv=COSMO.ENVIRON)
    button1 <- button(wName="button1",
                      wValue="Adapt sample constraints \n (non-advanced users)",
                      wFuns=list(command=mysample), wEnv=COSMO.ENVIRON, wWidth=25)
    button2 <- button(wName="button2",
                      wValue="Build from scratch \n (advanced users)",
                      wFuns=list(command=advanced), wEnv=COSMO.ENVIRON, wWidth=25)
    pWidgets <- list(A=list(label1=label1), B=list(button1=button1), C=list(button2=button2))
    if (interactive()) {
      ## remove COSMO.WIDGET on exit
      on.exit(rm(COSMO.WIDGET,pos=1),add=TRUE)
      COSMO.WIDGET <<- widget(wTitle="Constraint Builder", pWidgets, funs=list(), preFun=function() {},
                              postFun=function() {}, env=COSMO.ENVIRON)
    }

  }
  
  COSMO.CONSTRAINTS
}
