\name{constraintBuilder}
\alias{constraintBuilder}
\title{GUI assistance for constructing constraint sets}
\description{
  This command opens a series of user-friendly pop-up windows that will
  help the user adapt sample constraints or build new constraints from
  scratch.
}
\usage{
constraintBuilder()
}
\details{
  There are five sample constraints the user can modify: ICstep (the
  information content is a constant across the intervals), ICbound (the
  information content is bounded across each interval,
  V-shaped (the information content follows a symetric and continuous
  high-low-high), A-shaped (the information content follows a symetric
  and continuous low-high-low), Submotif (a segment of the motif is
  known).)  
  The uiser also has the option of building a constraint set from
  scratch. The user will then be taken through a step-by-step
  construction (interval setup, palindromic intervals constraints,
  information content constraints, nucleotide frequencies constraints
  and submotif constraints.)
  
}
\value{
  The function returns an object of class \code{constraint set}, which
  can be passed to \code{cosmo()} as the \code{constraints} argument or
  plotted using the \code{plot()} function.  
}
\author{
Fabian Gallusser, \email{fgallusser@berkeley.edu}
}
\seealso{
}
\examples{
#cs <- constraintBuilder()
#plot(cs)
}
\keyword{misc}
